/*4:*/
#line 106 "appevents.web"


#ifndef __APPEVENTS__
#define __APPEVENTS__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __COMMANDS__
#include <commands.h>
#endif

#define MAX_EVENTS 100
#define MAX_EVENT_TYPES 100
#define MAX_EVENT_PROCS 10

#define POS_BEFORE -1
#define POS_SUBSTITUTE 0
#define POS_AFTER 1

#define EAE_SECOND -1
#define EAE_UNKNOWN_TYPE -2
#define EAE_ALREADY_DEFINED_TYPE -3
#define EAE_TOO_MANY_TYPES -4
#define EAE_TOO_MANY_PROCS -5
#define TAE_TRACE_SEND 1
#define TAE_TRACE_GET 2
#define TAE_TRACE_DEFINE 3
#define TAE_TRACE_PROC 4

typedef void(*EventProc)(ptr,int,char*);

extern int InitAppEvents(int,int,void(*)(int,char*));
extern int DefineEventType(char*,int);
extern int SetEventProc(int,int,EventProc,EventProc,char*);
extern int SendAppEvent(int,char*,int,char*);
extern int GetAppEvent(int*,char**,int*,char**);
extern int InfEventTypes(void(*)(int,char*,char**,int,int));
extern int InfEvents(void(*)(int,char*,ptr,int,char*));
extern int SetEventTrace(int);
extern void CallProcs(int,ptr,int,char*);
extern int EventsCmd(command*);
#endif

/*:4*/
