/*2:*/
#line 47 "compadapt.web"

#ifndef __COMPADAPT__
#define __COMPADAPT__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __COMMANDS__
#include <commands.h>
#endif

#ifndef __TRIANG2__
#include <triang2.h>
#endif

/*3:*/
#line 74 "compadapt.web"


#define MAXSELS_E 16
#define MAXSELS_T 128

/*:3*/
#line 63 "compadapt.web"

/*4:*/
#line 82 "compadapt.web"

typedef int compSelsE;
typedef int compSelsT;
typedef int(*CompE)(EDG*,ptr);
typedef int(*CompT)(TR*,ptr);

/*:4*/
#line 64 "compadapt.web"

/*5:*/
#line 94 "compadapt.web"

extern int InitGeoVals(int,int);

/*:5*//*6:*/
#line 101 "compadapt.web"

extern compSelsE NewCompEVal(CompE proc,int lng,char*name);

/*:6*//*7:*/
#line 108 "compadapt.web"

extern compSelsT NewCompTVal(CompT proc,int lng,char*name);

/*:7*//*8:*/
#line 117 "compadapt.web"

extern int CompGlobalE(compSelsE sel);

/*:8*//*9:*/
#line 126 "compadapt.web"

extern int CompGlobalT(compSelsT sel);

/*:9*//*10:*/
#line 132 "compadapt.web"

extern void StopCompE(compSelsE sel);

/*:10*//*11:*/
#line 138 "compadapt.web"

extern void StopCompT(compSelsT sel);

/*:11*//*12:*/
#line 144 "compadapt.web"

extern int CheckCompE(compSelsE sel);

/*:12*//*13:*/
#line 150 "compadapt.web"

extern int CheckCompT(compSelsT sel);

/*:13*//*14:*/
#line 158 "compadapt.web"

extern int InitConstAss(real*p,real*g);

/*:14*//*15:*/
#line 165 "compadapt.web"

extern real**ConstAss(TR*t);
extern real*ConstAssR(TR*t);

/*:15*//*16:*/
#line 172 "compadapt.web"

extern real**ConstErrAss(TR*t);
extern real*ConstErrAssR(TR*t);

/*:16*//*17:*/
#line 180 "compadapt.web"

extern int CompDistrE(compSelsE sel,real*max,real*min,real*mean,
int*distr,int distrLng,int onlyMaxMin);

/*:17*//*18:*/
#line 188 "compadapt.web"

extern int CompDistrT(compSelsT sel,real*max,real*min,real*mean,
int*distr,int distrLng,int onlyMaxMin);

/*:18*//*19:*/
#line 195 "compadapt.web"

extern int InfCompAdaptCmd(command*);

/*:19*//*20:*/
#line 200 "compadapt.web"

extern int InfGeoCmd(command*);

/*:20*/
#line 65 "compadapt.web"

/*21:*/
#line 208 "compadapt.web"

extern compSelsE eValLng;
extern compSelsT tValArea;
extern compSelsT tConstAss;

/*:21*//*22:*/
#line 217 "compadapt.web"

extern int accCD;

/*:22*/
#line 66 "compadapt.web"


#endif

/*:2*/
