#   File:       minilib.make
#   Target:     minilib
#   Sources:    mginter.c psdriv.c macdriv.c mgenvir.c mgcsh.c
#   Created:    Tuesday, November 14, 1989 15:25:39

OBJECTS = mginter.c.o psdriv.c.o macdriv.c.o mgenvir.c.o mgcsh.c.o
COPTS = -mc68020 -mc68881 -i {KaskInterface} -sym on -d MACCOMP
CC = C

minilib  minilib.make {OBJECTS}
	Lib -o {kasklibraries}minilib.a {OBJECTS}
mginter.c.o  mginter.c minigraph.h
	 {CC} mginter.c {COPTS} -s minigr
psdriv.c.o  psdriv.c minigraph.h
	 {CC} psdriv.c {COPTS} -s minigr
macdriv.c.o  macdriv.c minigraph.h
	 {CC} macdriv.c {COPTS} -s minigr
mgenvir.c.o  mgenvir.c minigraph.h
	 {CC} mgenvir.c {COPTS} -s minigr
mgcsh.c.o  mgcsh.c minigraph.h {KaskInterface}c_parameter.h
	 {CC} mgcsh.c {COPTS} -s minigr
