/*3:*/
#line 173 "commands.web"

/*4:*/
#line 190 "commands.web"





/*:4*/
#line 174 "commands.web"

/*7:*/
#line 294 "commands.web"


#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include <zibutil.h>
#include <start.h>
#include <fixedsize.h>
#include <params.h>
#include <access.h>
#include <appevents.h>
#include <commands.h>

#ifdef TCL

# ifdef TCLX
#  include <tclExtend.h>
# else
# include <tcl.h>
#endif

Tcl_Interp*kaskInterp= nil;

/*:7*//*8:*/
#line 320 "commands.web"


#ifdef macintos
char*environ[]= {"KASKADE",nil};

void RotateCursor()
{return;}

void Feedback()
{return;}

void check_environment_set_of_globals(char*name,char*value)
{return;}
#endif
#endif

/*:8*//*9:*/
#line 338 "commands.web"


#define SKIPWHITE(tp) while(isspace(*(tp))) tp++;
#define SKIPSPACE(tp) while((*(tp)==' ')||(*(tp)=='\t')) tp++;
#define SKIPDIGITS(tp) while (isdigit(*(tp))) tp++;
#define SKIPTOCLASS(tp,class) while ((stdCmdModes.delimClass)[*(tp)]!=class) tp++;
#define SKIPUPTOCLASS(tp,class) while ((stdCmdModes.delimClass)[*(tp)]<class) tp++;
#define INCLASS(tp,class) ((stdCmdModes.delimClass)[*(tp)]==class)
#define UPTOCLASS(tp,class) ((stdCmdModes.delimClass)[*(tp)]>=class)
#define NOTINCLASS(tp,class) ((stdCmdModes.delimClass)[*(tp)]!=class)
#define NOTUPTOCLASS(tp,class) ((stdCmdModes.delimClass)[*(tp)]<class)

#define endClass 127
#define commandClass 10
#define parameterClass 5
#define nameClass 5
#define quoteClass 1


/*:9*//*10:*/
#line 360 "commands.web"


static char*initDefNames[]= 
{
"cmddelim",
"pardelim",
"quote",
"prompt",
"maxpars",
"escape",
"comment",
(char*)nil
};


static Names defNames= initDefNames;

static command staticCmd;
static char*globStartFileName= nil;

/*:10*//*11:*/
#line 411 "commands.web"


CMDMODES stdCmdModes= 
{
true,
99,
"Cmd:",
(TextElem*)nil,
10,
-1,
-1,
-1,
(Names)nil,
(int*)nil,
(CMDPROC*)nil,
(char**)nil,
(Names*)nil,
(CharClass)nil,
&staticCmd,
'\\',
'%',
false
};

/*:11*//*12:*/
#line 437 "commands.web"


static void SetAddresses(),PrintCmdSettings();
extern void PrintNames();
static int ReadCmdSettings(char**text,Names commandNames),
BuildNames(char**text),
ConvertNumber(char**text,int*no),
CmdQuit(command*cmd),CmdPrint(command*cmd),
CmdHelp(command*cmd),CmdVerbose(command*cmd),
CmdDo(command*cmd);
static int ZIBSysEvent();
#ifndef TCL
static void BreakPars(char**text,char**pars,int*no),
RemoveComment(char*tp);
#endif

#ifdef TCL
static int KaskCommand(ClientData clientData,Tcl_Interp*interp,
int argc,char*argv[]);
#endif

int goon= true,LineComplete,cmdError= false;
static int verbose= true;

/*:12*/
#line 175 "commands.web"

/*14:*/
#line 464 "commands.web"


static void SetAddresses()
{
SetCommand(0,CmdQuit);
SetCommand(1,CmdPrint);
#ifndef TCL
SetCommand(2,CmdDo);
#endif
SetCommand(3,CmdVerbose);
SetCommand(4,CmdHelp);
return;
}

/*:14*//*15:*/
#line 482 "commands.web"


void SetLibAddresses(int sel)
{
switch(sel)
{
case-1:
SetCommand(5,InfFixed);
SetCommand(6,InfAccess);
SetCommand(7,InfPar);
SetCommand(8,SetPar);
SetCommand(9,EventsCmd);
break;
case 1:
SetCommand(5,InfFixed);
break;
case 2:
SetCommand(6,InfAccess);
break;
case 3:
SetCommand(7,InfPar);
SetCommand(8,SetPar);
break;
case 4:
SetCommand(9,EventsCmd);
break;
}
return;
}

/*:15*//*16:*/
#line 517 "commands.web"


int MakeCharClasses()
{
int k;

if((stdCmdModes.delimClass)==nil)
stdCmdModes.delimClass= (char*)ZIBAlloc(256L);
if((stdCmdModes.delimClass)==nil)return false;
for(k= 0;k<256;k++)(stdCmdModes.delimClass)[k]= 0;
(stdCmdModes.delimClass)[NUL]= endClass;
(stdCmdModes.delimClass)['\n']= commandClass;
(stdCmdModes.delimClass)[';']= commandClass;
(stdCmdModes.delimClass)[' ']= parameterClass;
(stdCmdModes.delimClass)['=']= parameterClass;
(stdCmdModes.delimClass)['\t']= commandClass;
(stdCmdModes.delimClass)['\'']= quoteClass;
(stdCmdModes.delimClass)['\"']= quoteClass;
return true;
}

/*:16*//*17:*/
#line 547 "commands.web"


static int ReadCmdSettings(char**text,Names commandNames)
{
char*tp= *text,*tpReturn,*name;
int no;
CharClass delimClass= stdCmdModes.delimClass;

while(*tp=='$')
{
tp++;
name= tp;
no= CheckName(&tp,commandNames,nameClass);
switch(no)
{
case 0:
tp++;
delimClass[*tp]= commandClass;
break;
case 1:
tp++;
delimClass[*tp]= parameterClass;
break;
case 2:
tp++;
delimClass[*tp]= parameterClass;
break;
case 3:
SKIPSPACE(tp);
tpReturn= ConvertString(&tp,(char*)nil,0);
if(tpReturn==nil)
{
ZIBStdOut("Cmd: error reading string (Prompt)\n");
return false;
}
stdCmdModes.prompt= tpReturn;
break;
case 4:
SKIPSPACE(tp);
if(!ConvertNumber(&tp,&(stdCmdModes.maxPars)))
{
ZIBStdOut("Cmd: error reading number (MaxPar)\n");
return false;
}
break;
case 5:
SKIPSPACE(tp);
stdCmdModes.escape= *tp;;
break;
case 6:
SKIPSPACE(tp);
stdCmdModes.comment= *tp;;
break;
default:
SKIPUPTOCLASS(tp,nameClass);
sprintf(globBuf,"Cmd: unknown command '$%s'\n",name);
ZIBStdOut(globBuf);
SKIPUPTOCLASS(tp,commandClass);
return false;
}
SKIPUPTOCLASS(tp,commandClass);
SKIPWHITE(tp);
*text= tp;
}
return true;
}

/*:17*//*18:*/
#line 619 "commands.web"


static int BuildNames(char**text)
{
int maxInd= -1,k= 0,i,no;
char*tp= *text;
char*tempCmdNames[MAX_COM];
int tempCmdIndex[1000];
char*tempCmdShort[1000];
Names names;

SKIPWHITE(tp);
while((*tp!=NUL)&&(*tp!='$'))
{
tempCmdNames[k]= tp;
SKIPUPTOCLASS(tp,parameterClass);
if(*tp!=NUL){*tp= NUL;tp++;}
SKIPSPACE(tp);
if(!ConvertNumber(&tp,&(tempCmdIndex[k])))
{
sprintf(globBuf,"Cmd: error reading index for %s\n",
tempCmdNames[k]);
ZIBStdOut(globBuf);
return false;
}
if(tempCmdIndex[k]>maxInd)maxInd= tempCmdIndex[k];
SKIPSPACE(tp);
tempCmdShort[k]= ConvertString(&tp,(char*)nil,0);
k++;
if(k==(MAX_COM-1))
{
sprintf(globBuf,"Cmd: too many command names, maximum is %d\n",k);
ZIBStdOut(globBuf);
return false;
}
SKIPWHITE(tp);
}
maxInd++;
stdCmdModes.noOfNames= k;
stdCmdModes.maxIndex= maxInd;
stdCmdModes.names= (char**)ZIBAlloc((long)(k+1)*sizeof(Names));
if((stdCmdModes.names)==nil)
{
ZIBStdOut("BuildNames: not enough storage(names)\n");
return false;
}
stdCmdModes.index= (int*)ZIBAlloc((long)(k+1)*sizeof(int*));
if((stdCmdModes.index)==nil)
{
ZIBStdOut("BuildNames: not enough storage(index)\n");
return false;
}

stdCmdModes.shortDes= (char**)ZIBAlloc((long)(k+1)*sizeof(char**));
if((stdCmdModes.shortDes)==nil)
{
ZIBStdOut("BuildNames: not enough storage(short)\n");
return false;
}
stdCmdModes.procs= (CMDPROC*)ZIBAlloc((long)(maxInd+1)*sizeof(CMDPROC*));
if((stdCmdModes.procs)==nil)
{
ZIBStdOut("BuildNames: not enough storage(procs)\n");
return false;
}
stdCmdModes.pars= (Names*)ZIBAlloc((long)(maxInd+1)*sizeof(Names*));
if((stdCmdModes.pars)==nil)
{
ZIBStdOut("BuildNames: not enough storage(pars)\n");
return false;
}
for(i= 0;i<k;i++)
{
(stdCmdModes.names)[i]= tempCmdNames[i];
(stdCmdModes.index)[i]= tempCmdIndex[i];
(stdCmdModes.shortDes)[i]= tempCmdShort[i];
}
(stdCmdModes.names)[k]= nil;
(stdCmdModes.index)[k]= -1;
(stdCmdModes.shortDes)[k]= nil;
for(i= 0;i<maxInd;i++)
{
(stdCmdModes.procs)[i]= nil;
(stdCmdModes.pars)[i]= nil;
}
while(*tp=='$')
{
tp++;
if(!ConvertNumber(&tp,&no))
{
ZIBStdOut("Cmd: missing number for parameter keyword list\n");
return false;
}

if((no<0)||(no>maxInd))
{
sprintf(globBuf,
"Cmd: %d not allowed to be used as a procedure index, maximum is %d\n",
no,maxInd);
ZIBStdOut(globBuf);
return false;
}

k= 0;
while((*tp!=NUL)&&(*tp!='$'))
{
SKIPWHITE(tp);
tempCmdNames[k]= tp;
SKIPUPTOCLASS(tp,nameClass);
if(*tp!=NUL){*tp= NUL;tp++;}
k++;
}
names= (char**)ZIBAlloc((long)(k+1)*sizeof(char*));
if(names==nil)
{
ZIBStdOut("BuildNames: not enough storage(pars)\n");
return false;
}
for(i= 0;i<k;i++)names[i]= tempCmdNames[i];
names[k]= nil;
(stdCmdModes.pars)[no]= names;
SKIPWHITE(tp);
}
*text= tp;
return true;
}


/*:18*//*19:*/
#line 756 "commands.web"


int InitCommands(char*path,char*name,char*startFileName)
{
char completeFileName[256],*text;
long fileLng;
int k;

globStartFileName= startFileName;
if(!MakeCharClasses())return false;

strcpy(completeFileName,path);
strcat(completeFileName,name);

text= Z_FRead(d_mainModulID,completeFileName,&fileLng);
if(text==nil)
{
strcat(completeFileName,".");
strcat(completeFileName,"def");
text= Z_FRead(d_mainModulID,completeFileName,&fileLng);
}
if(text==nil)
{
sprintf(globBuf,"Cmd: can't read init-file '%s'\n",
completeFileName);
ZIBStdOut(globBuf);
return false;
}
if(!ReadCmdSettings(&text,defNames))
{ZIBStdOut("Cmd: error in reading settings\n");return false;}
if(!BuildNames(&text))
{ZIBStdOut("Cmd: errors in reading names\n");return false;}
(stdCmdModes.cmd)->pars= (char**)ZIBAlloc((long)MAX_PAR*sizeof(char*));
if(((stdCmdModes.cmd)->pars)==nil)
{
ZIBStdOut("InitCommand: not enough storage(pars)\n");
return false;
}
for(k= 0;k<MAX_PAR;k++)((stdCmdModes.cmd)->pars)[k]= nil;
stdCmdModes.textStack= 
(TextElem*)ZIBAlloc((long)(stdCmdModes.maxCmdStack)*sizeof(TextElem));
staticCmd.results= (char*)ZIBAlloc((long)1024);
if(((stdCmdModes.textStack)==nil)||((staticCmd.results)==nil))
{
ZIBStdOut("InitCommand: not enough storage(textStack)\n");
return false;
}

#ifdef TCL

# ifdef TCLX
kaskInterp= Tcl_CreateExtendedInterp();
# else
kaskInterp= Tcl_CreateInterp();
# endif
#endif

SetAddresses();
return true;
}

/*:19*/
#line 176 "commands.web"

/*21:*/
#line 824 "commands.web"


int DoCommands(char*lineBuf,void(*userproc)(char*))
{
if((stdCmdModes.cmdStackP)==(stdCmdModes.maxCmdStack))
{
sprintf(globBuf,"Cmd: too many active do file(s): %d\n",
stdCmdModes.cmdStackP);
ZIBStdOut(globBuf);
return false;
}
(stdCmdModes.cmdStackP)++;
(stdCmdModes.textStack)[stdCmdModes.cmdStackP].text= lineBuf;
(stdCmdModes.textStack)[stdCmdModes.cmdStackP].pos= lineBuf;
(stdCmdModes.textStack)[stdCmdModes.cmdStackP].tproc= userproc;
return true;
}

/*:21*//*22:*/
#line 845 "commands.web"


#ifndef TCL
int ExecCommand(command*cmd)
{
if((stdCmdModes.procs)[cmd->no]==nil)
{
sprintf(globBuf,"Cmd: no code for '%s'(%d)\n",
(cmd->pars)[0],cmd->no);
ZIBStdOut(globBuf);
return false;
}
return((stdCmdModes.procs)[cmd->no])(cmd);
}
#endif

/*:22*//*23:*/
#line 865 "commands.web"


#ifndef TCL
command*GetNextCommand()
{
char*tp,*name,tSave;
int no;
TextElem*te;
command*stdCmd= stdCmdModes.cmd;

if((stdCmdModes.cmdStackP)==-1)
{ZIBStdOut("Cmd: nothing to do\n");goon= false;return nil;}
te= &((stdCmdModes.textStack)[stdCmdModes.cmdStackP]);
tp= te->pos;
RemoveComment(tp);
while(*tp==NUL)
{
if((te->tproc)!=nil)(te->tproc)(te->text);
(stdCmdModes.cmdStackP)--;
if((stdCmdModes.cmdStackP)==-1)return nil;
te= &((stdCmdModes.textStack)[stdCmdModes.cmdStackP]);
tp= te->pos;
}
name= tp;
no= CheckName(&tp,stdCmdModes.names,nameClass);
if(no==-1)
{
SKIPUPTOCLASS(tp,nameClass);
tSave= *tp;*tp= NUL;
if((*name)!=NUL)
{
sprintf(globBuf,"Cmd: unknown command '%s'\n",name);
ZIBStdOut(globBuf);
}
*tp= tSave;
SKIPUPTOCLASS(tp,commandClass);
if(*tp!=NUL)tp++;
SKIPWHITE(tp);
te->pos= tp;
return(command*)-1L;
}
if(NOTUPTOCLASS(tp,commandClass)){*tp= NUL;tp++;}
stdCmd->no= (stdCmdModes.index)[no];
stdCmd->names= (stdCmdModes.pars)[(stdCmdModes.index)[no]];
(stdCmd->pars)[0]= name;
BreakPars(&tp,stdCmd->pars,&(stdCmd->noOfPars));
SKIPWHITE(tp);
te->pos= tp;
stdCmd->results= staticCmd.results;
stdCmd->verbose= verbose;
(stdCmd->results)[0]= NUL;
return stdCmd;
}
#endif

/*:23*//*24:*/
#line 924 "commands.web"


#ifdef TCL
static int KaskCommand(ClientData clientData,Tcl_Interp*interp,
int argc,char*argv[])
{
command cmd;
int no= (int)clientData,rc;

cmd.no= no;
cmd.noOfPars= argc-1;
cmd.pars= argv;
cmd.names= (stdCmdModes.pars)[no];
cmd.results= staticCmd.results;
cmd.verbose= verbose;
(cmd.results)[0]= NUL;

rc= ((stdCmdModes.procs)[no])(&cmd);
Tcl_SetResult(interp,cmd.results,TCL_VOLATILE);
return rc?TCL_OK:TCL_ERROR;
}
#endif

/*:24*//*25:*/
#line 950 "commands.web"


void SetCommand(int no,CMDPROC userproc)
{
#ifdef TCL
int k;
#endif
if((no<0)||(no>=(stdCmdModes.maxIndex)))
{
sprintf(globBuf,"Cmd: %d not allowed to be used as a procedure index, maximum is %d\n",
no,stdCmdModes.maxIndex);
ZIBStdOut(globBuf);
return;
}
(stdCmdModes.procs)[no]= userproc;

#ifdef TCL
for(k= 0;k<stdCmdModes.maxIndex;k++)
if((stdCmdModes.index)[k]==no)
{
Tcl_CreateCommand(kaskInterp,(stdCmdModes.names)[k],KaskCommand,
(ClientData)no,(Tcl_CmdDeleteProc*)nil);

}
#endif

return;
}

/*:25*//*26:*/
#line 981 "commands.web"


#ifndef TCL
static void BreakPars(char**text,char**pars,int*no)
{
char*tp= *text,*sp;
int k= 1;

SKIPSPACE(tp);
if(UPTOCLASS(tp,commandClass))
{
if(*tp!=NUL){*tp= NUL;tp++;}
*text= tp;
pars[1]= nil;
*no= 0;
return;
}
if(stdCmdModes.noParBreak)
{
pars[1]= tp;
sp= tp;
while((*sp!=NUL)&&(*sp!='\n'))
{
if(*sp==stdCmdModes.escape)
{
sp++;
switch(*sp)
{
case NUL:break;
case'n':*tp= '\n';break;
case't':*tp= '\t';break;
case'0':*tp= '\0';break;
case'\n':sp++;break;
default:*tp= *sp;break;
}
}
else*tp= *sp;
tp++;sp++;
}
if(*sp!=NUL)sp++;
*tp= NUL;
*no= 1;
pars[2]= NUL;
*text= sp;
return;
}
while(*tp!=NUL)
{
SKIPSPACE(tp);
if(INCLASS(tp,quoteClass))
{
pars[k]= ConvertString(&tp,(char*)nil,0);
if(pars[k]==nil)
{
ZIBStdOut("Cmd: closing string quote missing\n");
break;
}
else
{
k++;
if(*tp=='='){pars[k]= "=";k++;}
}
}
else
{
pars[k]= tp;k++;
SKIPUPTOCLASS(tp,parameterClass);
if(*tp=='=')
{
if(*pars[k-1]=='=')pars[k-1]= "=";
else{pars[k]= "=";k++;}
}
}
if(INCLASS(tp,commandClass))
{if(*tp!=NUL){*tp= NUL;tp++;}break;}
else
{if(*tp!=NUL){*tp= NUL;tp++;}}
}
*text= tp;
if(*(pars[k-1])==NUL)
k--;
pars[k]= nil;
*no= k-1;

return;
}
#endif

/*:26*//*27:*/
#line 1073 "commands.web"


#ifndef TCL

static void RemoveComment(char*tp)
{
int commentMode= false;

while(NOTINCLASS(tp,commandClass)&&NOTINCLASS(tp,endClass))
{
if((*tp)==(stdCmdModes.comment))commentMode= true;
if(commentMode)*tp= ' ';
tp++;
}
return;
}
#endif



/*:27*//*28:*/
#line 1098 "commands.web"


static int ConvertNumber(char**text,int*no)
{
int k,rc;
char*tp= *text;

rc= sscanf(tp,"%d",&k);
if(rc==1)
{
*no= k;
SKIPSPACE(tp);
if(((*tp)=='+')||((*tp)=='-'))tp++;
SKIPDIGITS(tp);
*text= tp;
return true;
}
return true;
}

/*:28*//*29:*/
#line 1125 "commands.web"


char*ConvertString(char**text,char*target,int max)
{
char*sp= *text,*tp;
char quote,escape= stdCmdModes.escape;

SKIPTOCLASS(sp,quoteClass);
quote= *sp;
sp++;
if(target==nil){target= sp;max= 99999;}
tp= target;

while(*sp!=quote)
{
if(*sp!=escape)
{
switch(*sp)
{
case NUL:
case'\n':*text= sp;return nil;
default:*tp= *sp;break;
}
}
else
{
sp++;
switch(*sp)
{
case NUL:break;
case'n':*tp= '\n';break;
case't':*tp= '\t';break;
case'0':*tp= '\0';break;
default:*tp= *sp;break;
}
}
sp++;tp++;max--;
if(max<0)return nil;
}
*tp= NUL;
*text= sp+1;
return target;
}

/*:29*//*30:*/
#line 1179 "commands.web"



int CheckName(char**text,Names names,int charClass)
{
int no= 0;
char*p,*q,*firstNonBlank= *text;

SKIPSPACE(firstNonBlank);
while(names[no]!=nil)
{
p= firstNonBlank;
q= names[no];
while(((stdCmdModes.ignoreCases)?(isupper(*p)?tolower(*p):*p):*p)==*q)
{
if((*p==NUL)&&(*q==NUL))break;
p++;q++;
}
if((*q==NUL)&&(UPTOCLASS(p,charClass)))
{*text= p;return no;}
no++;
}
return-1;
}

/*:30*//*31:*/
#line 1208 "commands.web"


int ParsCheck(command*cmd,int min,int max)
{
int no= cmd->noOfPars;

if(no<min)
{
sprintf(globBuf,"Cmd: %s: not enough parameters\n",
(cmd->pars)[0]);
ZIBStdOut(globBuf);
return true;
}
if(no>max)
{
sprintf(globBuf,"Cmd: %s: too many parameters\n",
(cmd->pars)[0]);
ZIBStdOut(globBuf);
return true;
}
return false;
}

/*:31*//*32:*/
#line 1233 "commands.web"


int ReadIntPar(command*cmd,int k,int*intVal)
{
int rc= 1,no;

if(k<=(cmd->noOfPars))
rc= sscanf((cmd->pars)[k],"%d",&no);
if(rc!=1)
{
sprintf(globBuf,"%s: '%s' should be followed by a number\n",
(cmd->pars)[0],(cmd->pars)[k-1]);
ZIBStdOut(globBuf);
return false;
}
*intVal= no;

return true;
}

/*:32*//*33:*/
#line 1254 "commands.web"


int ReadDoublePar(command*cmd,int k,double*doubleVal)
{
int rc= 1;
double x;

if(k<=(cmd->noOfPars))
rc= sscanf((cmd->pars)[k],"%le",&x);
if(rc!=1)
{
sprintf(globBuf,"%s: '%s' should be followed by a number\n",
(cmd->pars)[0],(cmd->pars)[k-1]);
ZIBStdOut(globBuf);
return false;
}
*doubleVal= x;

return true;
}

/*:33*//*34:*/
#line 1279 "commands.web"


int AddCmdPar(char*cmdName,char*parName)
{
char**oldParNames,**newParNames,*tp= cmdName;
int i,k,l;

k= CheckName(&tp,stdCmdModes.names,nameClass);
if(k>0)k= (stdCmdModes.index)[k];
if(k<0)
{
sprintf(globBuf,"AddCmdPar: Cannot find command '%s'\n",cmdName);
ZIBStdOut(globBuf);
}
oldParNames= (stdCmdModes.pars)[k];
if(oldParNames==nil)i= 0;
else{i= 0;while(oldParNames[i]!=nil)i++;}
newParNames= (char**)ZIBAlloc((i+2)*sizeof(char*));
if(newParNames==nil)return-1;
for(l= 0;l<i;l++)newParNames[l]= oldParNames[l];
newParNames[i]= parName;
newParNames[i+1]= nil;
ZIBFree((ptr)oldParNames);
(stdCmdModes.pars)[k]= newParNames;

return i;
}

/*:34*//*35:*/
#line 1312 "commands.web"


static int CmdQuit(command*cmd)
{
if(ParsCheck(cmd,0,0))return false;
goon= false;
return true;
}

/*:35*//*36:*/
#line 1324 "commands.web"


static int CmdPrint(command*cmd)
{
char*tp;
int no;

if(ParsCheck(cmd,0,1))return false;
if((cmd->verbose)==0)return true;
if((cmd->noOfPars)==0)
{PrintCmdSettings();PrintNames();}
else
{
tp= (cmd->pars)[1];
no= CheckName(&tp,cmd->names,nameClass);
switch(no)
{
case 0:PrintNames();break;
case 1:PrintCmdSettings();break;
default:
sprintf(globBuf,"Cmd: unknown parameter name '%s' for '%s'n",
(cmd->pars)[1],(cmd->pars)[0]);
ZIBStdOut(globBuf);
break;
}
}
return true;
}

/*:36*//*37:*/
#line 1356 "commands.web"


static void PrintCmdSettings()
{
ZIBStdOut("Cmd: current settings of the command interpreter\n");
sprintf(globBuf,"   Prompt:'%s'\n",stdCmdModes.prompt);
ZIBStdOut(globBuf);
sprintf(globBuf,"   Maximal number of parameters: %d\n",stdCmdModes.maxPars);
ZIBStdOut(globBuf);
if(stdCmdModes.ignoreCases)ZIBStdOut("   Cases are ignored\n");
sprintf(globBuf,"   Escape symbol: '%c'\n",stdCmdModes.escape);
ZIBStdOut(globBuf);
sprintf(globBuf,"   Comment symbol: '%c'\n",stdCmdModes.comment);
ZIBStdOut(globBuf);
return;
}

/*:37*//*38:*/
#line 1376 "commands.web"


void PrintNames()
{
int k= 0,i;
Names names;

ZIBStdOut("Cmd: list of commands:\n");
while((stdCmdModes.names)[k]!=nil)
{
sprintf(globBuf,"%-11.10s %3d %8x %s\n",(stdCmdModes.names)[k],
(stdCmdModes.index)[k],
(unsigned int)(stdCmdModes.procs)[(stdCmdModes.index)[k]],
(stdCmdModes.shortDes)[k]);
ZIBStdOut(globBuf);
names= (stdCmdModes.pars)[(stdCmdModes.index)[k]];
i= 0;
if(names!=nil)
{
while((*names)!=nil)
{
if(i==0)ZIBStdOut("      ");
else{if((i%6)==0)ZIBStdOut("\n      ");}
sprintf(globBuf,"%-11.10s",*names);
ZIBStdOut(globBuf);
names++;
i++;
}
ZIBStdOut("\n");
}
k++;
}
return;
}

/*:38*//*39:*/
#line 1414 "commands.web"


#ifndef TCL
static void ReturnText(char*text)
{
Z_ReturnFileBuf(&text);
return;
}
static int CmdDo(command*cmd)
{
char*text,fileName[256];
long fileLng;

if(ParsCheck(cmd,1,1))return false;
text= Z_FRead(d_mainModulID,(cmd->pars)[1],&fileLng);
if(text==nil)
{
strcpy(fileName,(cmd->pars)[1]);
strcat(fileName,".");
strcat(fileName,"ksk");
text= Z_FRead(d_mainModulID,fileName,&fileLng);
}
if(text==nil)return false;
return DoCommands(text,(void(*)(char*))ReturnText);
}
#endif

/*:39*//*40:*/
#line 1444 "commands.web"


static int CmdHelp(command*cmd)
{
char*tp;
Names names= stdCmdModes.names;
int no,i= 0;

if(ParsCheck(cmd,0,1))return false;
if((cmd->noOfPars)==0)
{
if((cmd->verbose)==0)return true;
ZIBStdOut("Help: list of commands:\n");
while((*names)!=nil)
{
if(i==0)ZIBStdOut("      ");
else{if((i%6)==0)ZIBStdOut("\n      ");}
sprintf(globBuf,"%-11.10s",*names);
ZIBStdOut(globBuf);
names++;
i++;
}
ZIBStdOut("\n");
}
else
{
tp= (cmd->pars)[1];
no= CheckName(&tp,stdCmdModes.names,nameClass);
if(no<0)
{
sprintf(globBuf,"Help: unknown command '%s'\n",
(cmd->pars)[1]);
ZIBStdOut(globBuf);
}
else
{
if((cmd->verbose)==0)return true;
sprintf(globBuf,"Help: %-11.10s: '%s'; parameters:\n",
(stdCmdModes.names)[no],
(stdCmdModes.shortDes)[no]);
ZIBStdOut(globBuf);
names= (stdCmdModes.pars)[(stdCmdModes.index)[no]];
i= 0;
if(names!=nil)
{
while((*names)!=nil)
{
if(i==0)ZIBStdOut("      ");
else{if((i%6)==0)ZIBStdOut("\n      ");}
sprintf(globBuf,"%-11.10s",*names);
ZIBStdOut(globBuf);
names++;
i++;
}
ZIBStdOut("\n");
}
}
}
return true;
}


/*:40*//*41:*/
#line 1509 "commands.web"


int SetVerbose(int newVerbose)
{
int oldVerbose= verbose;
verbose= newVerbose;
return oldVerbose;
}

static int CmdVerbose(command*cmd)
{
int newVerbose;

if(ParsCheck(cmd,1,1))return false;
sscanf((cmd->pars)[1],"%d",&newVerbose);
sprintf(cmd->results,"%d",SetVerbose(newVerbose));
return true;
}

/*:41*/
#line 177 "commands.web"

/*42:*/
#line 1530 "commands.web"


#ifndef TCL
void CmdMainLoop()
{
command*cmd;
int type,lng;
char*name,buffer[256];
ptr value;

strcpy(buffer,"do ");
strcat(buffer,globStartFileName);
LineComplete= DefineEventType("line input",false);
SendAppEvent(LineComplete,buffer,14,"first event");

while(goon)
{
if(!GetAppEvent(&type,&value,&lng,&name))break;
if(type==LineComplete)DoCommands((char*)value,(void(*)(char*))nil);
else goon= false;
while(goon)
{
cmd= GetNextCommand();
if(cmd==nil)break;
if(cmd==((command*)-1))continue;
if(!ExecCommand(cmd))cmdError= true;
}
if(goon&&!ZIBSysEvent())break;
}
return;
}
#else

void CmdMainLoop()
{
int type,lng,rc;
char*name,buffer[256];
ptr value;

strcpy(buffer,"rename source do; do ellkask.startup");
LineComplete= DefineEventType("line input",false);
SendAppEvent(LineComplete,buffer,14,"first event");

while(goon)
{
if(!GetAppEvent(&type,&value,&lng,&name))break;
if(type==LineComplete)
{
rc= Tcl_RecordAndEval(kaskInterp,(char*)value,0);
if(*(kaskInterp->result)!=NUL)
{
ZIBStdOut(">");
ZIBStdOut(kaskInterp->result);
ZIBStdOut("\n");
}
}
else goon= false;
if(goon&&!ZIBSysEvent())break;
}
return;
}
#endif

/*:42*//*43:*/
#line 1595 "commands.web"


static int ZIBSysEvent()
{
char*lineBuf= ZIBStdLine(stdCmdModes.prompt);

SendAppEvent(LineComplete,lineBuf,strlen(lineBuf),"input line");
return true;
}

/*:43*/
#line 178 "commands.web"


/*:3*/
