#   File:       graphlib.make
#   Target:     graphlib
#   Sources:    graphic.c graphcmd.c graph3d.c
#   Created:    Samstag, 12. Februar 1992 12:43:50 Uhr


OBJECTS = graphic.c.o graphcmd.c.o graph3d.c.o
COPTS = -mc68020 -mc68881 -i {KaskInterface} -sym on -model far # -trace on
CC = C


graphlib  graphlib.make {OBJECTS}
	Lib -o {kasklibraries}graphlib.a {OBJECTS}
graphic.c.o  graphic.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}params.h {KaskInterface}appevents.h 
			 {KaskInterface}access.h {KaskInterface}nodes.h 
			 {KaskInterface}triang2.h {KaskInterface}solve.h 
			 {KaskInterface}arcedges.h {KaskInterface}graphic.h
	 {CC} {COPTS} -s graphic graphic.c
graphcmd.c.o  graphcmd.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}access.h {KaskInterface}nodes.h 
			 {KaskInterface}triang2.h {KaskInterface}problem.h 
			 {KaskInterface}graphic.h
	 {CC} {COPTS} -s graphcmd graphcmd.c
graph3d.c.o  graph3d.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}params.h {KaskInterface}appevents.h 
			 {KaskInterface}access.h {KaskInterface}nodes.h 
			 {KaskInterface}triang2.h {KaskInterface}solve.h 
			 {KaskInterface}arcedges.h {KaskInterface}graphic.h
	 {CC} {COPTS} -s graph3d graph3d.c
