#   File:       kasklib.make
#   Target:     kasklib
#   Sources:    access.c fixedsize.c portab.c params.c
#               commands.c rahmen.c
#   Created:    Samstag, 30. November 1991 15:17:51 Uhr


OBJECTS = access.c.o appevents.c.o fixedsize.c.o portab.c.o params.c.o 
          commands.c.o rahmen.c.o
COPTS = -mc68020 -mc68881 -i {KaskInterface} -sym on -model far # -trace on
CC = C

kasklib  kasklib.make {OBJECTS}
	Lib -o {KaskLibraries}KaskLib.a {OBJECTS}
access.c  access.web
	 ctangle access dummy
	 cweave access dummy
	 move -y access.h {KaskInterface}access.h
access.c.o  access.c {KaskInterface}zibutil.h {KaskInterface}commands.h
	 {CC} {COPTS} -s access access.c
appevents.c  appevents.web
	 ctangle appevents dummy
	 cweave appevents dummy
	 move -y appevents.h {KaskInterface}appevents.h
appevents.c.o  appevents.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
              {KaskInterface}commands.h
	 {CC} {COPTS} -s appevents appevents.c
commands.c  commands.web
	 ctangle commands dummy
	 cweave commands dummy
	 move -y commands.h {KaskInterface}commands.h
commands.c.o  commands.c {KaskInterface}zibutil.h 
			 {KaskInterface}fixedsize.h {KaskInterface}access.h 
			 {KaskInterface}appevents.h {KaskInterface}params.h
	 {CC} {COPTS} -s commands commands.c -d macintosh
fixedsize.c  fixedsize.web
	 ctangle fixedsize dummy
	 cweave fixedsize dummy
	 move -y fixedsize.h {KaskInterface}fixedsize.h
fixedsize.c.o  fixedsize.c {KaskInterface}zibutil.h {KaskInterface}commands.h
	 {CC} {COPTS} -s fixedsize fixedsize.c
params.c  params.web
	 ctangle params dummy
	 cweave params dummy
	 move -y params.h {KaskInterface}params.h
params.c.o  params.c {KaskInterface}zibutil.h {KaskInterface}commands.h
	 {CC} {COPTS} -s params params.c
portab.c  portab.web
	 ctangle portab dummy
	 cweave portab dummy
	 move -y zibutil.h {KaskInterface}zibutil.h
portab.c.o  portab.c
	 {CC} {COPTS} -s portab portab.c
rahmen.c.o  rahmen.c
	 {CC} {COPTS} -s rahmen rahmen.c
rahmen.c  rahmen.web
	 ctangle rahmen dummy
	 cweave rahmen dummy
	 Move start.h {KaskInterface} -y
