/*5:*/
#line 147 "portab.web"

/*6:*/
#line 153 "portab.web"


#include <stdio.h>
#include <string.h>

#include <zibutil.h>

/*:6*//*7:*/
#line 166 "portab.web"


#define ALLIGN_SKIP 8
long allocMem= 0L;

/*:7*//*10:*/
#line 213 "portab.web"


#include <time.h>
#include <stdlib.h>

#ifdef unix
#include <sys/times.h>
#include <unistd.h>
#endif

/*:10*//*12:*/
#line 259 "portab.web"


static FILE*outFile= stdout;

/*:12*//*16:*/
#line 310 "portab.web"


static char lineBuf[256];

/*:16*/
#line 148 "portab.web"

/*8:*/
#line 175 "portab.web"


void*ZIBAlloc(long size)
{
char*buf= (char*)malloc((int)(size+ALLIGN_SKIP));

if(buf!=nil)allocMem+= size;
else
{
sprintf(globBuf,"Forced termination due to memory request failure (%ld new bytes)\n",size);
ZIBStdOut(globBuf);
exit(2);
}
memset(buf,NUL,(int)(size+ALLIGN_SKIP));
*((long*)buf)= size;
return(void*)(buf+ALLIGN_SKIP);
}

/*:8*//*9:*/
#line 195 "portab.web"


void*ZIBFree(void*buf)
{
char*retBuf= (char*)buf-ALLIGN_SKIP;

if(buf==nil)return nil;
allocMem-= *((long*)retBuf);
free(retBuf);

return nil;
}

/*:9*//*11:*/
#line 225 "portab.web"


real ZIBSeconds()
{
#ifdef unix
real tim,clocks_per_second;
struct tms now;

# ifdef CLOCKS_PER_SEC
clocks_per_second= CLOCKS_PER_SEC;
# else
#   ifdef CLK_TCK
clocks_per_second= CLK_TCK;
#   else
clocks_per_second= sysconf(_SC_CLK_TCK);
#   endif
# endif

times(&now);
tim= (now.tms_utime)/clocks_per_second;
return tim;
#else
clock_t t= clock();
real x= t;

return x/CLOCKS_PER_SEC;
#endif
}

/*:11*//*13:*/
#line 266 "portab.web"


void ZIBOutFile(char*s)
{
if((s==nil)||(s[0]=='\0'))
{
if(outFile)
if(outFile!=stdout)fclose(outFile);
outFile= stdout;
return;
}
outFile= fopen(s,"w");
if(outFile==nil)
{
printf("Emergency stop, '%s' already opened?\n",s);
exit(2);
}
return;
}

/*:13*//*14:*/
#line 289 "portab.web"


void ZIBStdOut(char*s)
{
fputs(s,outFile);fflush(stdout);
return;
}

/*:14*//*15:*/
#line 299 "portab.web"


void ZIBNL()
{
putc('\n',outFile);fflush(outFile);
return;
}

/*:15*//*17:*/
#line 319 "portab.web"


char*ZIBStdLine(char*prompt)
{
*lineBuf= NUL;
fputs(prompt,stdout);
fflush(stdout);
if(fgets(lineBuf,256,stdin)==nil){
if(*lineBuf==NUL){
fprintf(outFile,"No response from input\n");
return nil;
}else{
fprintf(outFile,"Line longer than 254 characters\n");
lineBuf[255]= NUL;
}
}
return lineBuf;
}

/*:17*/
#line 149 "portab.web"


/*:5*/
