#   File:       triang2lib.make
#   Target:     triang2lib
#   Sources:    geointer.c refine.c nodes.c
#               tricmd.c arcedges.c prvals.c readtr.c
#               sparsemat.c renumb.c
#   Created:    Samstag, 12. Februar 1992 12:43:50 Uhr


OBJECTS = geointer.c.o refine.c.o nodes.c.o readtr.c.o 
          tricmd.c.o arcedges.c.o prvals.c.o sparsemat.c.o 
		  renumb.c.o sread.c.o
COPTS = -mc68020 -mc68881 -i {KaskInterface} -sym on -model far # -trace on
CC = C


triang2lib  triang2lib.make {OBJECTS}
	Lib -o {kasklibraries}triang2lib.a {OBJECTS}
geointer.c.o  geointer.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
			 {KaskInterface}triang2.h
	 {CC} geointer.c {COPTS} -s geointer
refine.c.o  refine.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
             {KaskInterface}triang2.h
	 {CC} refine.c {COPTS} -s refine
tricmd.c.o  tricmd.c {KaskInterface}zibutil.h 
             {KaskInterface}commands.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h
	 {CC} tricmd.c {COPTS} -s tricmd
arcedges.c.o  arcedges.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
			 {KaskInterface}fixedsize.h {KaskInterface}access.h 
			 {KaskInterface}nodes.h {KaskInterface}triang2.h
	 {CC} arcedges.c {COPTS} -s arcedges
readtr.c.o  readtr.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}commands.h {KaskInterface}appevents.h 
			 {KaskInterface}arcedges.h 
			 {KaskInterface}nodes.h {KaskInterface}triang2.h
	 {CC} readtr.c {COPTS} -s readtr
sread.c.o  sread.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}commands.h {KaskInterface}appevents.h 
			 {KaskInterface}arcedges.h 
			 {KaskInterface}nodes.h {KaskInterface}triang2.h
	 {CC} sread.c {COPTS} -s sread
prvals.c.o  prvals.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}nodes.h {KaskInterface}triang2.h
	 {CC} prvals.c {COPTS} -s prvals
nodes.c.o  nodes.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h {KaskInterface}appevents.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h
	 {CC} nodes.c {COPTS} -s nodes
sparsemat.c.o  sparsemat.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h {KaskInterface}appevents.h 
			 {KaskInterface}problem.h 
			 {KaskInterface}assemble.h {KaskInterface}solve.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h
	 {CC} sparsemat.c {COPTS} -s sparsemat
renumb.c.o  renumb.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h 
			 {KaskInterface}triang2.h {KaskInterface}nodes.h
	 {CC} renumb.c {COPTS} -s renumb
