#   File:       solve3lib.make
#   Target:     solve3lib
#   Sources:    problem.c shape.c localass.c stdproblem.c
#               solsetup.c solcmd.c cg.c bicgstab.c ssor.c hb.c bpx.c cholfull.c cholenv.c
#   Created:    Samstag, 12. Februar 1992 12:43:50 Uhr

Kask3dInterface = kaskade:ZIB-bib:Interfaces3:

OBJECTS = problem.c.o shape.c.o localass.c.o stdproblem.c.o 
          solsetup.c.o solcmd.c.o cg.c.o ssor.c.o hb.c.o bpx.c.o 
		  cholfull.c.o  cholenv.c.o bicgstab.c.o 
		  ellesti.c.o
COPTS = -mc68020 -mc68881 -i {Kask3dInterface} -i {KaskInterface} -sym on -model far -warnings off
CC = C

solve3lib  solve3lib.make {OBJECTS}
	Lib -o {kasklibraries}solve3lib.a {OBJECTS}
problem.c.o  problem.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {Kask3dInterface}problem3.h
	 {CC} problem.c {COPTS} -s problem
shape.c.o  shape.c {KaskInterface}zibutil.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}problem3.h {Kask3dInterface}assemble3.h
	 {CC} shape.c {COPTS} -s shape
localass.c.o  localass.c {KaskInterface}zibutil.h {KaskInterface}triang2.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}assemble3.h
	 {CC} localass.c {COPTS} -s localass
stdproblem.c.o  stdproblem.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}params.h {Kask3dInterface}problem3.h
	 {CC} stdproblem.c {COPTS} -s stdproblem -w
solsetup.c.o  solsetup.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}appevents.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}assemble3.h {Kask3dInterface}solve3.h
	 {CC} solsetup.c {COPTS} -s solsetup
solcmd.c.o  solcmd.c {KaskInterface}zibutil.h {KaskInterface}commands.h 
			 {KaskInterface}appevents.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}assemble3.h {Kask3dInterface}solve3.h
	 {CC} solcmd.c {COPTS} -s solcmd
cg.c.o  cg.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h 
			 {Kask3dInterface}problem3.h {Kask3dInterface}solve3.h
	 {CC} cg.c {COPTS} -s cg
bicgstab.c.o  bicgstab.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h 
			 {Kask3dInterface}problem3.h {Kask3dInterface}solve3.h
	 {CC} bicgstab.c {COPTS} -s bicgstab
ssor.c.o  ssor.c {KaskInterface}zibutil.h {KaskInterface}access.h 
             {KaskInterface}params.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h {Kask3dInterface}assemble3.h
	 {CC} ssor.c {COPTS} -s ssor
hb.c.o  hb.c {KaskInterface}zibutil.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h
	 {CC} hb.c {COPTS} -s hb
bpx.c.o  bpx.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}params.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h
	 {CC} bpx.c {COPTS} -s bpx
cholfull.c.o  cholfull.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h
	 {CC} cholfull.c {COPTS} -s cholfull
cholenv.c.o  cholenv.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h
	 {CC} cholenv.c {COPTS} -s cholenv
ellesti.c.o  ellesti.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}assemble.h {Kask3dInterface}triang3.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}problem3.h 
			 {Kask3dInterface}solve3.h
	 {CC} ellesti.c {COPTS} -s ellesti
