#   File:       ellkask.make
#   Target:     ellkask
#   Sources:    ellkask.c user.c
#   Created:    Dienstag, 24. Januar 1989 16:48:48 Uhr

COPT = -mc68881 -mc68020 -d MACCOMP -sym on -w -i {KaskInterface} -model far # -trace on
LOPT = -sn ProffSeg=main -sym on

ellkask.c.o  ellkask.c
	C ellkask.c {COPT} -d STACKSIZE=64 -s ellkask # -d PERFORMANCE
user.c.o  user.c
	C user.c {COPT} -s user

SOURCES = ellkask.c user.c
OBJECTS = ellkask.c.o user.c.o

ellkask  kaskade.r
    Rez kaskade.r -append -o ellkask
	Rez -a "{RIncludes}"SIOW.r -o ellkask
	SetFile -a B ellkask -c KASK -t APPL
ellkask  {OBJECTS} ellkask.make 
           "{KaskLibraries}"KaskLib.a  
           "{KaskLibraries}"Triang2Lib.a  
           "{KaskLibraries}"SolveLib.a 
		   "{KaskLibraries}"GraphLib.a 
		   "{KaskLibraries}"minilib.a 
		   "{KaskLibraries}"libtcl.a
	Link -w -c KASK -t APPL -model far 
		{OBJECTS} 
		"{KaskLibraries}"SolveLib.a 
		"{KaskLibraries}"GraphLib.a 
		"{KaskLibraries}"Triang2Lib.a 
		"{KaskLibraries}"KaskLib.a 
		"{KaskLibraries}"minilib.a 
#		"{KaskLibraries}"libtcl.a 
		"{CLibraries}"Clib881.o 
		"{CLibraries}"CSANELib881.o 
		"{CLibraries}"Math881.o 
		"{CLibraries}"StdClib.o 
#		"{Libraries}"Proff.o 
		"{Libraries}"SIOW.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
#		"{Libraries}"PerformLib.o 
		-o ellkask {LOPT} -l > ellkask.linkmap
