/*6:*/
#line 126 "params.web"


#ifndef __PARAMS__
#define __PARAMS__

#ifndef __ZIBUTIL__
#include <zibutil.h>
#endif

#ifndef __COMMANDS__
#include <commands.h>
#endif

#define MAX_PARAMS_LISTS 100

#define EPM_DOUBLE_INIT -1
#define EPM_MEMORY -2
#define EPM_ALREADY_USED -3
#define EPM_TOO_MANY -4
#define EPM_NOT_DEFINED -5
#define EPM_NOT_FOUND -6

#define T_INT 0
#define T_REAL 1
#define T_BOOL 2

extern int InitParams(int,void(*)(int,char*));
extern ptr NewParamList(ptr,char*,int,int,char**,int,int,char**,ptr,
int(*)(char*,char*,int),int(*)(char*));
extern int ReturnParamList(char*);
extern int GetParam(char*,char*,ptr*);
extern int GetParamList(char*,char***,ptr*,int*,int*,int*,char***,ptr*);
extern char**GetListNames(int*);
extern int ChangeParam(char*,char*,ptr,char*);
extern int ChangedParamList(char*);
extern int InfPar(command*cmd),SetPar(command*cmd);
#endif

/*:6*/
