/*4:*/
#line 81 "portab.web"


#ifndef __ZIBUTIL__
#define __ZIBUTIL__

#ifndef true
#define true 1
#define false 0
#endif

#ifndef nil
#define nil 0L
#endif

#ifndef NUL
#define NUL '\0'
#endif

#define ZERO 0.0
#define ONE 1.0
#define TWO 2.0
#define THREE 3.0
#define FOUR 4.0
#define EIGHT 8.0
#define HALF 0.5
#define QUARTER 0.25
#define THIRD    0.333333333333333333333
#define TWOTHIRD 0.666666666666666666667
#define SIXTH    0.166666666666666666667
#define RMIN -1.0E20
#define RMAX 1.0E20
#define REALPI   (3.14159265358979323846)
#define REALPI2  (1.57079632679489661923)
#define SQRT3    (1.73205080756887719318)
#define SQRT2    (1.41421356237309514547)

typedef double REAL;
typedef char*PTR;
typedef int(*PROC)();
typedef REAL(*REALPROC)();
typedef PTR(*PTRPROC)();
typedef void(*VOIDPROC)();

typedef double real;
typedef char*ptr;
typedef int(*proc)();
typedef REAL(*realproc)();
typedef PTR(*ptrproc)();
typedef void(*voidproc)();

extern void*ZIBAlloc(long);
extern void*ZIBFree(void*);
extern real ZIBSeconds();
extern void ZIBOutFile(char*);
extern void ZIBStdOut(char*);
extern void ZIBNL();
extern char*ZIBStdLine(char*);

extern long allocMem;
extern char*globBuf;
#endif

/*:4*/
