#   File:       triang3lib.make
#   Target:     triang3lib
#   Sources:    geointer.c refine.c nodes.c
#               tricmd.c arcedges.c prvals.c readtr.c
#               sparsemat.c renumb.c
#   Created:    Samstag, 12. Februar 1992 12:43:50 Uhr

Kask3dInterface = kaskade:ZIB-bib:Interfaces3:

OBJECTS = geointer.c.o refine.c.o nodes.c.o readtr.c.o 
          tricmd.c.o arcedges.c.o prvals.c.o sparsemat.c.o 
		  renumb.c.o
COPTS = -mc68020 -mc68881 -i {Kask3dInterface} -i {KaskInterface} -sym on -model far -warnings off
CC = C


triang3lib  triang3lib.make {OBJECTS}
	Lib -o {kasklibraries}triang3lib.a {OBJECTS}
geointer.c.o  geointer.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
			 {Kask3dInterface}triang3.h
	 {CC} geointer.c {COPTS} -s geointer
refine.c.o  refine.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
             {Kask3dInterface}triang3.h
	 {CC} refine.c {COPTS} -s refine
tricmd.c.o  tricmd.c {KaskInterface}zibutil.h 
             {KaskInterface}commands.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h
	 {CC} tricmd.c {COPTS} -s tricmd
arcedges.c.o  arcedges.c {KaskInterface}zibutil.h {KaskInterface}appevents.h 
			 {KaskInterface}fixedsize.h {KaskInterface}access.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}triang3.h
	 {CC} arcedges.c {COPTS} -s arcedges
readtr.c.o  readtr.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {KaskInterface}commands.h {KaskInterface}appevents.h 
			 {Kask3dInterface}arcedges.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}triang3.h
	 {CC} readtr.c {COPTS} -s readtr
prvals.c.o  prvals.c {KaskInterface}zibutil.h {KaskInterface}access.h 
			 {Kask3dInterface}nodes3.h {Kask3dInterface}triang3.h
	 {CC} prvals.c {COPTS} -s prvals
nodes.c.o  nodes.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h {KaskInterface}appevents.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h
	 {CC} nodes.c {COPTS} -s nodes
sparsemat.c.o  sparsemat.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h {KaskInterface}appevents.h 
			 {Kask3dInterface}problem3.h 
			 {Kask3dInterface}assemble3.h {Kask3dInterface}solve3.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h
	 {CC} sparsemat.c {COPTS} -s sparsemat
renumb.c.o  renumb.c {KaskInterface}zibutil.h {KaskInterface}fixedsize.h 
			 {KaskInterface}access.h 
			 {Kask3dInterface}triang3.h {Kask3dInterface}nodes3.h
	 {CC} renumb.c {COPTS} -s renumb
